diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index 85cd53ee9..aefb04f7f 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -1,8 +1,7 @@
 package net.minecraft.server.entity.player;
 
 import net.minecraft.core.achievement.stat.Stat;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockPortal;
+import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.*;
 import net.minecraft.core.crafting.ContainerListener;
@@ -50,8 +49,8 @@ public class PlayerServer extends Player implements ContainerListener {
     public PlayerServer(MinecraftServer minecraftserver, World world, String username, UUID uuid, ServerPlayerController serverPlayerController)
     {
         super(world);
-        loadedChunks = new LinkedList();
-        field_420_ah = new HashSet();
+        loadedChunks = new LinkedList<>();
+        field_420_ah = new HashSet<>();
         lastHealth = 0xfa0a1f01;
         lastScore = 0xfa0a1f01;
         ticksOfInvuln = 60;
@@ -302,10 +301,10 @@ public class PlayerServer extends Player implements ContainerListener {
 
         if (inPortal)
         {
-            int targetDim = ((BlockPortal) Blocks.blocksList[portalID]).targetDimension;
+            Dimension targetDim = ((BlockLogicPortal) Blocks.blocksList[portalID].getLogic()).targetDimension;
             boolean netherAllowed = mcServer.propertyManager.getBooleanProperty("allow-nether", true);
             boolean paradiseAllowed = mcServer.propertyManager.getBooleanProperty("allow-paradise", false);
-            if ((netherAllowed && targetDim == Dimension.NETHER.id) || (paradiseAllowed && targetDim == Dimension.PARADISE.id) || (targetDim != Dimension.NETHER.id && targetDim != Dimension.PARADISE.id))
+            if ((netherAllowed && targetDim == Dimension.NETHER) || (paradiseAllowed && targetDim == Dimension.PARADISE) || (targetDim != Dimension.NETHER && targetDim != Dimension.PARADISE))
             {
                 if (craftingInventory != inventorySlots)
                 {
@@ -322,13 +321,13 @@ public class PlayerServer extends Player implements ContainerListener {
                     {
                         timeInPortal = 1.0F;
                         timeUntilPortal = 10;
-                        if (dimension == targetDim)
+                        if (dimension == targetDim.id)
                         {
                             mcServer.playerList.sendPlayerToOtherDimension(this, 0, portalColor, true);
                         }
                         else
                         {
-                            mcServer.playerList.sendPlayerToOtherDimension(this, targetDim, portalColor, true);
+                            mcServer.playerList.sendPlayerToOtherDimension(this, targetDim.id, portalColor, true);
                         }
                     }
                 }
@@ -374,10 +373,10 @@ public class PlayerServer extends Player implements ContainerListener {
                     WorldServer worldserver = mcServer.getDimensionWorld(dimension);
                     loadedChunks.remove(chunkCoord);
                     playerNetServerHandler.sendPacket(new PacketBlockRegionUpdate(chunkCoord.x * Chunk.CHUNK_SIZE_X, 0, chunkCoord.z * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, worldserver));
-                    List list = worldserver.getBlockEntitiesWithinBounds(chunkCoord.x * Chunk.CHUNK_SIZE_X, 0, chunkCoord.z * Chunk.CHUNK_SIZE_Z, chunkCoord.x * Chunk.CHUNK_SIZE_X + Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, chunkCoord.z * Chunk.CHUNK_SIZE_Z + Chunk.CHUNK_SIZE_Z);
+                    List<TileEntity> list = worldserver.getBlockEntitiesWithinBounds(chunkCoord.x * Chunk.CHUNK_SIZE_X, 0, chunkCoord.z * Chunk.CHUNK_SIZE_Z, chunkCoord.x * Chunk.CHUNK_SIZE_X + Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, chunkCoord.z * Chunk.CHUNK_SIZE_Z + Chunk.CHUNK_SIZE_Z);
                     for (int j = 0; j < list.size(); j++)
                     {
-                        getTileEntityInfo((TileEntity) list.get(j));
+                        getTileEntityInfo(list.get(j));
                     }
                 }
             }
@@ -538,7 +537,7 @@ public class PlayerServer extends Player implements ContainerListener {
 	public void displayFurnaceScreen(TileEntityFurnace blockEntity)
     {
         getNextWindowId();
-        if (blockEntity instanceof TileEntityFurnaceBlastFurnace)
+        if (blockEntity instanceof TileEntityFurnaceBlast)
         {
             playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_BLAST_FURNACE, blockEntity.getName(), blockEntity.getContainerSize()));
         }
diff --git a/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
index 588a3a41f..f4fca8d05 100644
--- a/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
+++ b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
@@ -31,7 +31,7 @@ public class ServerPlayerController
             int j = thisWorld.getBlockId(destroyX, destroyY, destroyZ);
             if(j != 0)
             {
-                Block block = Blocks.blocksList[j];
+                Block<?> block = Blocks.blocksList[j];
                 float f = block.blockStrength(thisWorld, destroyX, destroyY, destroyZ, destroySide, player) * (float)(i + 1);
                 if(f >= 1.0F)
                 {
@@ -51,7 +51,7 @@ public class ServerPlayerController
 			return;
 		}
 		blockHitTicks = ticksRan;
-		Block block = thisWorld.getBlock(x, y, z);
+        Block<?> block = thisWorld.getBlock(x, y, z);
 		if(block != null && block.blockStrength(thisWorld, x, y, z, side, player) >= 1.0F) {
 			mineBlock(x, y, z, side);
 		} else {
@@ -63,7 +63,7 @@ public class ServerPlayerController
     
 	public void hitBlock(int x, int y, int z, Side side, double xHit, double yHit) {
 		thisWorld.onBlockHit(player, x, y, z, side);
-		Block block = thisWorld.getBlock(x, y, z);
+        Block<?> block = thisWorld.getBlock(x, y, z);
 		if(block != null) {
 			block.onBlockLeftClicked(thisWorld, x, y, z, player, side, xHit, yHit);
 		}
@@ -77,7 +77,7 @@ public class ServerPlayerController
             int i1 = thisWorld.getBlockId(x, y, z);
             if(i1 != 0)
             {
-                Block block = Blocks.blocksList[i1];
+                Block<?> block = Blocks.blocksList[i1];
                 float f = block.blockStrength(thisWorld, x, y, z, side, player) * (float)(l + 1);
                 if(f >= 0.7F)
                 {
@@ -99,8 +99,8 @@ public class ServerPlayerController
 
     public boolean removeBlock(int x, int y, int z)
     {
-        Block block = Blocks.blocksList[thisWorld.getBlockId(x, y, z)];
-        int l = thisWorld.getBlockMetadata(x, y, z);
+//        Block<?> block = Blocks.blocksList[thisWorld.getBlockId(x, y, z)];
+//        int l = thisWorld.getBlockMetadata(x, y, z);
         return thisWorld.setBlockWithNotify(x, y, z, 0);
     }
 
@@ -116,7 +116,7 @@ public class ServerPlayerController
     			return false;
     		}
     	}
-        Block block = Blocks.getBlock(id);
+        Block<?> block = Blocks.getBlock(id);
         TileEntity tileEntity = thisWorld.getBlockEntity(x, y, z);
         thisWorld.playBlockEvent(player, LevelListener.EVENT_BLOCK_BREAK, x, y, z, id);
         boolean flag = removeBlock(x, y, z);
